﻿init python:
    def load_map(tilemap):
        map = []
        file = open(renpy.loader.transfn(tilemap),"r")
        for y,line in enumerate(file):
            line = line.strip()
            line = line.split(",")
            row = []
            for x,tile in enumerate(line):
                row.append([int(tile), (x, y)])
            map.append(row)
        file.close()
        return map

    def load_tiles(img, size, y = 8, x = 8):
        tiles = []
        for i in range(x):
            for ii in range(y):
                tiles.append(Crop((ii*size,i*size,size,size), img))
        return tiles

    class map_manager:
        def __init__(self, map, tile_size_x, tile_size_y, tiles, zoom):
            self.map = load_map(map)
            self.half_x = tile_size_x/2
            self.half_y = tile_size_y/2

            self.zoom = zoom
            fx = len(self.map[0])*tile_size_x
            fy = len(self.map)*tile_size_y
            self.frame_pos = (1920/2, (1080 - fy*self.zoom)/2)
            self.frame_size = (fx, fy)
            self.set = load_tiles(tiles, tile_size_x, 4, 4)
        def change_tile(self, x, y, tile):
            self.map[y][x] = tile
        def get_clicked_tile(self):
            x,y = renpy.get_mouse_pos()
            x,y = x-self.frame_pos[0], y-self.frame_pos[1]
            x,y = x/self.zoom, y/self.zoom
            x += 0
            y -= 0
            mx = (x / self.half_x + y / self.half_y)/2
            my = (y / self.half_y - x / self.half_x)/2
            renpy.notify((mx, my))


screen iso_tile(g = test_map):
    modal True
    button xysize g.frame_size align .5,.5 padding 0,0:
        # background "#555"
        at zoom(g.zoom, True)
        action Function(g.get_clicked_tile)
        fixed fit_first True align .5,.0 yoffset -g.half_y:
            for row in g.map:
                for tile in row:
                    if tile[0] != -1:
                        add g.set[tile[0]] offset (tile[1][0] - tile[1][1])*g.half_x, (tile[1][0] + tile[1][1])*g.half_y

    vbox:
        text str(len(g.map[0]))
        text str(len(g.map))
        text str(len(g.set))

    # frame:
    #     xysize 10,10 pos g.frame_pos background "#fff"

    button align 1.0,1.0 offset -20,-20:
        text "Next"
        action Return()

default test_map = map_manager(
    "tile/iso 32 test.csv", 32, 16,
    "iso_test_map",
    4,
    )
default test_map_64 = map_manager(
    "tile/iso 64.csv", 64, 32,
    "iso 64",
    2,
    )

label isometric_tile_test:
    call screen iso_tile
    call screen iso_tile(test_map_64)